<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.ruoyi.system.mapper.projectV2.ZsyzProjectDeptMapper">
    
    <resultMap type="ZsyzProjectDept" id="ZsyzProjectDeptResult">
        <result property="id"    column="id"    />
        <result property="xmId"    column="xm_id"    />
        <result property="xmbh"    column="xmbh"    />
        <result property="xmmc"    column="xmmc"    />
        <result property="deptId"    column="dept_id"    />
        <result property="deptName"    column="dept_name"    />
        <result property="ancestors"    column="ancestors"    />
        <result property="isHf"    column="is_hf"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectZsyzProjectDeptVo">
        select id, xm_id, xmbh, xmmc, dept_id, dept_name, ancestors,is_hf, create_by, create_time, update_by, update_time, remark from zsyz_project_dept
    </sql>

    <select id="selectZsyzProjectDeptList" parameterType="ZsyzProjectDept" resultMap="ZsyzProjectDeptResult">
        <include refid="selectZsyzProjectDeptVo"/>
        <where>  
            <if test="xmId != null "> and xm_id = #{xmId}</if>
            <if test="xmbh != null  and xmbh != ''"> and xmbh = #{xmbh}</if>
            <if test="xmmc != null  and xmmc != ''"> and xmmc = #{xmmc}</if>
            <if test="deptId != null "> and dept_id = #{deptId}</if>
            <if test="isHf != null and isHf != ''"> and is_hf = #{isHf}</if>
            <if test="deptName != null  and deptName != ''"> and dept_name like concat('%', #{deptName}, '%')</if>
            <if test="ancestors != null  and ancestors != ''"> and ancestors = #{ancestors}</if>
        </where>
    </select>
    
    <select id="selectZsyzProjectDeptById" parameterType="Long" resultMap="ZsyzProjectDeptResult">
        <include refid="selectZsyzProjectDeptVo"/>
        where id = #{id}
    </select>
    <select id="selectZsyzProjectDeptByXmId" parameterType="ZsyzProjectDept" resultMap="ZsyzProjectDeptResult">
        <include refid="selectZsyzProjectDeptVo"/>
        <where>
            <if test="xmId != null "> and xm_id = #{xmId}</if>
            <if test="xmbh != null  and xmbh != ''"> and xmbh = #{xmbh}</if>
            <if test="xmmc != null  and xmmc != ''"> and xmmc = #{xmmc}</if>
            <if test="deptId != null "> and dept_id = #{deptId}</if>
            <if test="isHf != null and isHf != ''"> and is_hf = #{isHf}</if>
            <if test="deptName != null  and deptName != ''"> and dept_name like concat('%', #{deptName}, '%')</if>
            <if test="ancestors != null  and ancestors != ''"> and ancestors = #{ancestors}</if>
        </where>
        order by create_time DESC limit 1
    </select>

    <insert id="insertZsyzProjectDept" parameterType="ZsyzProjectDept" useGeneratedKeys="true" keyProperty="id">
        insert into zsyz_project_dept
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="xmId != null">xm_id,</if>
            <if test="xmbh != null">xmbh,</if>
            <if test="xmmc != null">xmmc,</if>
            <if test="deptId != null">dept_id,</if>
            <if test="deptName != null">dept_name,</if>
            <if test="ancestors != null">ancestors,</if>
            <if test="isHf != null">is_hf,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="xmId != null">#{xmId},</if>
            <if test="xmbh != null">#{xmbh},</if>
            <if test="xmmc != null">#{xmmc},</if>
            <if test="deptId != null">#{deptId},</if>
            <if test="deptName != null">#{deptName},</if>
            <if test="ancestors != null">#{ancestors},</if>
            <if test="isHf != null">#{isHf},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateZsyzProjectDept" parameterType="ZsyzProjectDept">
        update zsyz_project_dept
        <trim prefix="SET" suffixOverrides=",">
            <if test="xmId != null">xm_id = #{xmId},</if>
            <if test="xmbh != null">xmbh = #{xmbh},</if>
            <if test="xmmc != null">xmmc = #{xmmc},</if>
            <if test="deptId != null">dept_id = #{deptId},</if>
            <if test="deptName != null">dept_name = #{deptName},</if>
            <if test="ancestors != null">ancestors = #{ancestors},</if>
            <if test="isHf != null and is_hf != ''">is_hf = #{isHf},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where id = #{id}
    </update>
    <update id="updateZsyzProjectDeptByXmId" parameterType="ZsyzProjectDept">
        update zsyz_project_dept set is_hf = 'Y' where xm_id = #{xmId} and dept_id = #{deptId}
    </update>

    <delete id="deleteZsyzProjectDeptById" parameterType="Long">
        delete from zsyz_project_dept where id = #{id}
    </delete>

    <delete id="deleteZsyzProjectDeptByIds" parameterType="String">
        delete from zsyz_project_dept where id in 
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>
</mapper>